using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class PainAgent : TemporaryBodyLiquid 
    {
        public PainAgent()
        {
            Color = new Color(1f, 0.34f, 0.51f);
        }

        public override void OnEnterContainer(BloodContainer container)
        {            
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
            if(container is CirculationBehaviour circ)
            {
                circ.Limb.Person.AddPain(5f * Time.deltaTime);
            }
        }
    
        public override void OnExitContainer(BloodContainer container)
        {            
        }
    }

    public class MagnaDolore : TemporaryBodyLiquid   //scientists are still bad at naming things :(  //not anymore :D
    {
        public MagnaDolore()
        {
            Color = new Color(1f, 0f, 0.27f);
        }

        public override void OnEnterContainer(BloodContainer container)
        {            
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
            limb.gameObject.AddComponent<PainInTheAss>();
            UnityEngine.Object.Destroy(limb.gameObject.GetComponent<NoPainInTheAss>());
        }

        public override void OnUpdate(BloodContainer container)
        {
            
        }
    
        public override void OnExitContainer(BloodContainer container)
        {            
        }
    }
    
    public class PainInTheAss : MonoBehaviour
    {
        LimbBehaviour limb;
        public void Awake()
        {
            limb = gameObject.GetComponent<LimbBehaviour>();
        }

        public void Update()
        {
            if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
            {
                limb.Person.ShockLevel = 1.0f;
                limb.Person.PainLevel = 1.0f;
            }
        }
    }
}